//<c>   Copyright 1998-2000 by Gerry J. Danen; all rights reserved.

//<t>   Apply the SHORTCUT program to all .LNK files on drive C:

#include"gd_tools.h"
#include"gd_files.h"
#include"gd_ansi.h"


#if     (! LARGE_MODEL)
  #error LARGE MEMORY MODEL REQUIRED
#endif


#if C_DOC

    Windows NT has the annoying habit of using UNC for shortcuts and the
    registry. This program fixes the shortcuts...

#endif


#define pgVERS_ "V1.02"
#define pgTITL_ "Create a batch file to apply SHORTCUT to all .LNK files on drive C:"
#define pgCOPR_ "1998"


char    dSaveInfo[FS_LEN] = "" ;                // remember where we came from on original drive
char    dSaveInfoOther[FS_LEN] = "" ;           // where we came from on other drive
char    curdir[FS_LEN] ;
UCHAR   sFileSearch[FS_LEN] = "*.lnk" ;         // file spec to search for
UCHAR   sDirSearch[FS_LEN] = "C:\\" ;           // directory to start the search
UCHAR   sOutFile[] = "LNKFIXER.BAT" ;           // name of output file
int     iMaxLevel = 32767, level = 0, maxlevel = 0, iFiles=0, iDirs=0 ;
FILE    *f ;


void    disk_save( void )
{
    _getcwd( dSaveInfo, sizeof(dSaveInfo) );    // get current directory on original drive
}


void    disk_restore( void )
{
    unsigned    ndrv ;

    _dos_setdrive( dSaveInfo[0] - 64, &ndrv );
    _chdir( dSaveInfo );                        // back to original
}


void    program_exit( void )
{
    if ( strlen(dSaveInfoOther) )
        _chdir( dSaveInfoOther );               // in case we went to a different drive
    disk_restore();                             // where we started from
    fclose( f );
}


void    program_init( int argc, char *argv[] )
{
    unsigned    ndrv ;

    tt_init( SHAREWARE_VERSION, 0, pgVERS_, pgTITL_, pgCOPR_ );

    disk_save();
    atexit( program_exit );

    logon( 1 );

    f = fopen( sOutFile, "w" );
    if ( f == NULL )
    {
        printf( "Cannot open batch file: %s\n", sOutFile );
        exit( 3 );
    }

    _dos_setdrive( sDirSearch[0] - 64, &ndrv ); // select drive
    _getcwd( dSaveInfoOther, sizeof(dSaveInfoOther) ); // get current directory on other drive
    _chdir( "\\" );
}


void    process_files( void )                   // recursive function ...
{
    char temp[4] ;
    int  done ;
    BOOL isRoot ;
    struct find_t dta ;

    level += 1 ;
    if ( level > maxlevel )
        maxlevel = level ;

    _getcwd( curdir, sizeof(curdir) );

    printf( "\r%79s\r%d: %s", " ", level, curdir );

    if ( (strlen(curdir) == 3) && (curdir[1] == DRIV_SEP_CH) )
        isRoot = TRUE ;
    else
        isRoot = FALSE ;

    if ( isRoot )
        fprintf( f, "@echo off\n echo Fixing .LNK files\n %c:\n", curdir[0] );

    done = _dos_findfirst( sFileSearch, REGULAR_FILES, &dta );  // all except directories, and volid
    if ( ! done )
    {
        fprintf( f, "\n cd \"%s\"\n echo ... %s\n", curdir, curdir );  // show path
        iDirs += 1 ;
    }

    while ( ! done )
    {
        fprintf( f, " shortcut -c -f -s -n \"%s\"\n", dta.name );
        iFiles += 1 ;
        done = _dos_findnext( &dta );
    }

    done = _dos_findfirst( "*.*", _A_SUBDIR+_A_SYSTEM+_A_HIDDEN, &dta );
    while ( ! done )                            // process directories
    {
        strncpy( temp, dta.name, 2 );
        if ( ((dta.attrib & _A_SUBDIR) == _A_SUBDIR) && (temp[0] != '.') )
        {
            if ( ! isRoot )
                strcat( curdir, "\\" );
            strcat( curdir, dta.name );
            if ( strlen(curdir) <= MAX_DOS_PATH_LENGTH )  // max allowed by DOS
            {
                _chdir( curdir );
                process_files();                // recursive call
                _chdir( ".." );
            }
            else
            {
                printf( "\r%79s\r** %s name too long for DOS program ... cannot process!\n", " ", curdir );
            }
            _getcwd( curdir, sizeof(curdir) );
        }
        done = _dos_findnext( &dta );
    }

    level -= 1 ;
}


void    main( int argc, char *argv[] )
{
    program_init( argc, argv );
    process_files();
    printf( "\r%79s\rSub-directories are nested %d levels deep...\n"
            "%d .LNK files processed in %d directories.", " ", maxlevel, iFiles, iDirs );
    exit( GOOD_EXIT );
}
